<template>
  <div class="TwoFA">
    <div class="title-page">
      {{ $t('profile_setting.title') }}
    </div>

    <div class="content-box">
      <p class="modal-title">{{ $t('otp.modal.title') }}</p>
      <div class="modal-body">
        <div class="otp-step">
          <div :class="`${isCurrentStep(step) ? 'active': ''} step-${step.step} step`" @click="selectStep(step)" v-for="step in steps">
            <span>{{ step.step }}</span>
          </div>
        </div>
        <div class="otp-step-container">
          <p class="otp-title">{{ $t('otp.modal.step', {step: current.step}) }}. {{ current.title}}</p>
          <component v-for="(step, index) in steps" :key="index" :is="step.component" @previous="prevStep()" @next="nextStep()" v-show="isCurrentStep(step)"></component>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import Install from '../components/TwoFA/Install.vue';
import QR from '../components/TwoFA/QR.vue';
import BackupKey from '../components/TwoFA/BackupKey.vue';
import EnableAuthentication from '../components/TwoFA/EnableAuthentication.vue';

export default {
  components: {
    Install,
    QR,
    BackupKey,
    EnableAuthentication,
  },
   data() {
    return {
      steps: [
        {
          step: 1,
          isPassed: true,
          title: 'Download App',
          component: 'Install',
        },
        {
          step: 2,
          isPassed: false,
          title: 'Scan QR Code',
          component: 'QR',
        },
        {
          step: 3,
          isPassed: false,
          title: 'Backup key',
          component: 'BackupKey',
        },
        {
          step: 4,
          isPassed: false,
          title: 'Enable Google Authentication',
          component: 'EnableAuthentication',
        },
      ],
      current: {},
    }
  },
  methods: {
    isCurrentStep (step) {
      return this.current.step === step.step;
    },
    selectStep (step) {
      if (step.isPassed && !this.isCurrentStep(step)) {
        this.current = step;
      }
    },
    nextStep() {
      const nextStep = this.current.step + 1;
      const current = this.steps.find(step => step.step === nextStep);
      current.isPassed = true;
      this.current = current;
    },
    prevStep() {
      const prevStep = this.current.step - 1;
      this.current = this.steps.find(step => step.step === prevStep);
    },
    closeModal() {
      this.$broadcast('close-modal');
    },
  },
  created () {
    this.current = this.steps[0];
  },
}
</script>
<style lang="scss" scoped>
  @import '../../../sass/mobile/typoVariables.scss';
  .TwoFA {
    background: $bg_primary;
  }
  .title-page {
    padding: 13rem 12rem 13rem;
    background-image: linear-gradient(to bottom, $midnight, $catalina_blue);
    box-shadow: 0 2rem 40rem 0 rgba(0, 0, 0, 0.5);
    font-size: 18rem;
    color: $white;
  }

  .title-page,
  .content-box {
    padding-left: 12rem;
    padding-right: 12rem;
  }

  .content-box {
    padding-top: 14rem;
    margin-bottom: 40rem;
    height: 400rem;
    position: relative;
  }

  .modal-title {
    @extend .bold-16;
    font-weight: bold;
  }

  .otp-step {
    margin-bottom: 24rem;
    &:after {
      content: '';
      display: table;
      clear: both;
    }

    .step {
      width: 25%;
      float: left;
      height: 40rem;
      display: table;
      position: relative;
      cursor: pointer;
      &:first-child {
        border-top-left-radius: 20rem;
        border-bottom-left-radius: 20rem;
      }
      &:last-child {
        border-top-right-radius: 20rem;
        border-bottom-right-radius: 20rem;
      }
      &:after {
        position: absolute;
        z-index: 2;
        height: 0;
        width: 0;
        right: -14rem;
        border-width: 20rem 0 20rem 15rem;
        border-style: solid;
      }
      &.active {
        background-color: $dark_orange !important;
        span {
          color: $white !important;
        }
        &:after {
          border-color: transparent transparent transparent $dark_orange !important;
        }
      }
      &.step-1 {
        background-color: #ededed;
        &:after {
          border-color: transparent transparent transparent #ededed;
          content: '',
        }
      }
      &.step-2 {
        background-color: #e5e5e5;
        &:after {
          border-color: transparent transparent transparent #e5e5e5;
          content: '',
        }
      }
      &.step-3 {
        background-color: #dbdbdb;
        &:after {
          border-color: transparent transparent transparent #dbdbdb;
          content: '',
        }
      }
      &.step-4 {
        background-color: #d3d3d3;
      }
      span {
        text-transform: uppercase;
        padding-left: 5rem;
        font-size: 12rem;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        letter-spacing: 0.5rem;
        text-align: center;
        color: $gray;
        display: table-cell;
        vertical-align: middle;
      }
    }
  }
  .otp-step-container {
    .otp-title {
      font-size: $small;
      font-weight: bold;
      color: $gray;
      margin-bottom: 6rem;
    }
  }
</style>

<style lang="scss">
  @import '../../../sass/mobile/app.scss';
  .btn-step {
    height: 32rem;
    border-radius: 30rem !important;
    font-size: 13rem !important;
    font-weight: bold;
    text-align: center;
    text-transform: uppercase !important;
    padding: 0;
    outline: none;
    cursor: pointer;
    i {
      font-family: FontAwesome;
      font-size: 14rem;
      font-weight: bold;
    }

    &:focus {
      outline: none;
    }
  }
  .btn-next-step,
  .btn-enable {
    width: 140rem;
    color: $orangeBold;
    border-radius: 30rem;
    border: solid 1rem $orangeBold;
    color: $white;
    background-color: $orangeBold;
  }
  .btn-prev-step {
    width: 145rem;
    border: solid 1rem #fa7300;
    color: #fa7300;
    background: transparent;
  }

  .btn-group {
    margin: 0 -6rem;
    font-size: 0;

    .btn-item {
      width: 50%;
      padding: 0 6rem;
      display: inline-block;

      .btn-step {
        width: 100%;
      }
    }
  }
</style>
